import { convertLexicalNodesToHTML } from '../index.js';
export const ParagraphHTMLConverter = {
  async converter({
    converters,
    currentDepth,
    depth,
    draft,
    node,
    overrideAccess,
    parent,
    req,
    showHiddenFields
  }) {
    const childrenText = await convertLexicalNodesToHTML({
      converters,
      currentDepth,
      depth,
      draft,
      lexicalNodes: node.children,
      overrideAccess,
      parent: {
        ...node,
        parent
      },
      req,
      showHiddenFields
    });
    const style = [node.format ? `text-align: ${node.format};` : '', node.indent > 0 ? `padding-inline-start: ${node.indent * 40}px;` : ''].filter(Boolean).join(' ');
    return `<p${style ? ` style='${style}'` : ''}>${childrenText}</p>`;
  },
  nodeTypes: ['paragraph']
};
//# sourceMappingURL=paragraph.js.map